import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.event.*;
import java.awt.event.MouseListener;
//**********************************************
public class ComputerSimulator extends Applet implements Runnable {
 private
   // nabor ukazov
   String opMnemonik[] = { "STOP", "PODPROGRAM","PAST","POVRATEK",   // mnemoniki ukazov
                          "VSTAVI","SHRANI_M","NALOZI_M", "VNOS", "IZPIS",
                          "PRISTEJ","ODSTEJ","MNOZI","DELI", 
                          "PRISTEJ_M","ODSTEJ_M","MNOZI_M","DELI_M",
                          "SKOK", "TEST_VECJE","TEST_ENAKO", "TEST_MANJSE","IE"
                         };
 int opKoda [] = {17,22,21,19,18,24,25,26,27,28,29,30,31,0,1,3,4,5,15,8,7,9};    //celostevilcna koda ukaza
   
   String programFile; // datoteka s programom
   Image imageCPE, imageArrow, imageKeyboard;
   int programCounter=0; 
   Stack<Integer> sklad = new Stack<Integer>();
   int cpeSpeed = 1000;  // hitrost CPE bv msec
   int akumulatorValue = 0;
   int prekinitvenaRutina = 0;  // lokacija prekinitvene rutine
   boolean interruptEnable = true;
   boolean runProgram = false;
   boolean repainted = false;
   boolean prikazTerminala = false;
   boolean prikazKomentarja = true;
   int prikazKode = 0;   // 0.. mnemonik (default), 1.. desetisko, 2..dvojisko
   boolean prekinitev = false;  // indikator simulirane  HW prekinitve
   int stKod = -1;  // stevilo kod (ukazov ali podatkov) v "programu" (v zacetku prazen pomnilnik)
   int memSize  = 20;  // size of simulated memory (number of cells)
   int osLimit = 0;   // do sem sega "operacijski sistem"
   String koda[] = new String[20];  // tu pomnimo zaporedje kod (ukazov ali podatkov)
   String komentar[] = new String[20];  // tu pomnimo komentar te vrstice
   boolean [] lokacijaDefinirana = new boolean[20]; // true, ce na lokaciji ukaz ali podatek, false sicer
   String komentarCPE1 = new String("Kaj naj naredim?");
   String komentarCPE2 = new String("");
   TextField akumulator;
   Checkbox rezultatNic, rezultatNegativen;  // simuliran processor status word
   TextArea zaslon;  // simulacija zaslona racunalnika
   // naslednje je potrebno zaradi dvojnega pomnenja animirane slike..
   Graphics bufferGr; 
   // The image that will contain everything that has been drawn on  bufferGraphics. 
   Image offScreen; 
   Dimension dim; // To get the width and height of the applet. 
   Thread thread;
   boolean running = false;
   Keyboard tipkovnica;

   
   MouseListener mouseListener = new MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        if((interruptEnable)) {
           interruptEnable = false;  //onemogoci nadaljnje interrupte
           prekinitev = true;
           komentarCPE1 = "Zaznal sem prekinitev:";
           komentarCPE2 = "Prekinjam program";
           sklad.push(programCounter); // to je podobno kot klic podprograma
           programCounter = prekinitvenaRutina;
           repaint();
        }
      }
    };
//********************************************************

   private class Keyboard extends Panel {
   // ta razred potrebujemo, da lahko na prikazano sliko damo Mouselistener
    public void paint(Graphics  g) {       
     g.drawImage(imageKeyboard, 0,0,198,63, this);
  }

}
   
//*********************************************************


  public void init() {
     for (int i=0;i<memSize;koda[i++]= ""); // "izpraznimo pomnilnik"
     for (int i=0;i<memSize;komentar[i++]= ""); // "izpraznimo komentarje"
     for (int i=0;i<memSize;lokacijaDefinirana[i++]= false); // lokacije niso vec definirane
     // branje morebitnih parametrov s HTML strani
     String param = getParameter("PRIKAZ_TERMINALA");
     if (param != null) if(param.equalsIgnoreCase("true")) prikazTerminala = true;
      param = getParameter("PRIKAZ_KOMENTARJA");
     if (param != null) if(param.equalsIgnoreCase("true")) prikazKomentarja = true;
     param = getParameter("PRIKAZ_KODE");
     if (param != null) prikazKode = Integer.parseInt(param); // default 0
     programFile = getParameter("PROGRAM");
     if (programFile != null) loadProgram(programFile);
     dim = getSize(); 
     setLayout(null);
     this.setBackground(Color.black);
     imageCPE = getImage(getCodeBase(), "cpe.gif");
     imageKeyboard = getImage(getCodeBase(), "keyboard.gif");
     imageArrow = getImage(getCodeBase(), "arrow.gif");
     // klik na tipkovnico simulira prekinitve...
     tipkovnica = new Keyboard();
     tipkovnica.setBounds(50,380,198,63);
     ///tipkovnica.addMouseListener(new PoslusalecTipkovnice());
     tipkovnica.addMouseListener(mouseListener);
     akumulator= new TextField();  
     rezultatNic = new Checkbox("Nic");  rezultatNegativen = new Checkbox("Neg");
     zaslon = new TextArea("Zaslon",5,20,3);
     akumulator.setBounds(90,240,90,20);
     rezultatNic.setBounds(90,270,40,20);
     rezultatNegativen.setBounds(140,270,40,20);
     rezultatNic.setBackground(new Color(189,222,222)); rezultatNegativen.setBackground(new Color(189,222,222));
     zaslon.setBounds(50,310,200,60);
     zaslon.setBackground(Color.blue); zaslon.setForeground(Color.white);
     this.add(akumulator);   
     this.add(rezultatNic);   this.add(rezultatNegativen);
     this.add(zaslon);
     this.add(tipkovnica);
     tipkovnica.setVisible(prikazTerminala);   zaslon.setVisible(prikazTerminala);
     // Create an offscreen image to draw on 
     // Make it the size of the applet, this is just perfect larger size could slow it down unnecessary. 
     offScreen = createImage(dim.width,dim.height); 
     // by doing this everything that is drawn by bufferGraphics will be written on the offscreen image. 
     bufferGr = offScreen.getGraphics(); 
    // nextCommand();
  }

  public void start() {
    if (thread == null) {
        thread = new Thread(this);
        thread.start();
    }
  }


  public void run() {
     while (thread != null) {
       try{
          thread.sleep(cpeSpeed);
          if (running) nextCommand();
       }
       catch(Exception e) {}
     }
  } 
 //*****************************************************************************
   public void nextCommand() {
     if ((programCounter >=0)||(programCounter < stKod)) {
        //ukaz izvedemo le, ce programCounter kaze na neko veljavno lokacijo
        String ukazStr = koda[programCounter];
        komentarCPE1 = " Izvajam ukaz:";
        komentarCPE2 = ukazStr;
        repainted= false;
        repaint(); // narisemo trenutno stanje, pred izvedbo ukaza
        while (! repainted);  // ne nadaljujemo, dokler ni zaslon osvezen
        StringTokenizer st = new StringTokenizer(ukazStr);
        // procesiranje ukaza
        String kodaUkaza = st.nextToken();  // to je operacija ukaza

        if (kodaUkaza.equalsIgnoreCase("VSTAVI")){
           int value = new Integer(st.nextToken()); // drugi operand je podatek
           akumulatorValue =  value;
        }
        else if (kodaUkaza.equalsIgnoreCase("PRISTEJ")){
           int value = new Integer(st.nextToken()); // drugi operand je podatek
           akumulatorValue = akumulatorValue + value;
        }
        else if (kodaUkaza.equalsIgnoreCase("ODSTEJ")){
           int value = new Integer(st.nextToken()); // drugi operand je podatek
           akumulatorValue = akumulatorValue - value; 
        }
         else if (kodaUkaza.equalsIgnoreCase("MNOZI")){
           int value = new Integer(st.nextToken()); // drugi operand je podatek
           akumulatorValue = akumulatorValue * value; 
        }
         else if (kodaUkaza.equalsIgnoreCase("DELI")){
           int value = new Integer(st.nextToken()); // drugi operand je podatek
           akumulatorValue = akumulatorValue / value; 
        }

        else if (kodaUkaza.equalsIgnoreCase("PRISTEJ_M")){
           int value = new Integer(st.nextToken()); // drugi operand je naslov podatka
           akumulatorValue = akumulatorValue +  Integer.parseInt(koda[value]); 
        }
        else if (kodaUkaza.equalsIgnoreCase("ODSTEJ_M")){
           int value = new Integer(st.nextToken()); // drugi operand je naslov podatka
           akumulatorValue = akumulatorValue - Integer.parseInt(koda[value]);  
        }
        else if (kodaUkaza.equalsIgnoreCase("MNOZI_M")){
           int value = new Integer(st.nextToken()); // drugi operand je naslov podatka
           akumulatorValue = akumulatorValue * Integer.parseInt(koda[value]); 
        }
        else if (kodaUkaza.equalsIgnoreCase("DELI_M")){
           int value = new Integer(st.nextToken()); // drugi operand je naslov podatka
           akumulatorValue = akumulatorValue / Integer.parseInt(koda[value]); 
        }             
        else if (kodaUkaza.equalsIgnoreCase("SHRANI_M")){
           int value = new Integer(st.nextToken()); // drugi operand je naslov pomnilne lokacije
           koda[value] = new Integer(akumulatorValue).toString(); 
           lokacijaDefinirana[value] = true;  // vsebina pomn. lokacije je sedaj znana
        }
        else if (kodaUkaza.equalsIgnoreCase("NALOZI_M")){
           int value = new Integer(st.nextToken()); // drugi operand je naslov pomnilne lokacije
           akumulatorValue = Integer.parseInt(koda[value]); 
        }
        else if (kodaUkaza.equalsIgnoreCase("SKOK")){
           programCounter = new Integer (st.nextToken()) - 1;
        }
        else if (kodaUkaza.equalsIgnoreCase("TEST_VECJE")){
            if (akumulatorValue > 0) programCounter = new Integer (st.nextToken()) - 1;
        }
         else if (kodaUkaza.equalsIgnoreCase("TEST_MANJSE")){
            if (akumulatorValue < 0) programCounter = new Integer (st.nextToken()) - 1;
        }
          else if (kodaUkaza.equalsIgnoreCase("TEST_ENAKO")){
            if (akumulatorValue == 0) programCounter = new Integer (st.nextToken()) - 1;
        }
        else if (kodaUkaza.equalsIgnoreCase("PODPROGRAM")){
          sklad.push(new Integer(programCounter));  // shrani zaradi povratka
           programCounter = new Integer (st.nextToken()) - 1;
        }
        else if (kodaUkaza.equalsIgnoreCase("PAST")){
          sklad.push(new Integer(programCounter));  // shrani zaradi povratka
           programCounter = new Integer (st.nextToken()) - 1;
        }
        else if (kodaUkaza.equalsIgnoreCase("IE")){
           if(st.nextToken().equals("1")) interruptEnable = true; else interruptEnable = false;
        }
        else if (kodaUkaza.equalsIgnoreCase("POVRATEK")){
           programCounter = sklad.pop();
           interruptEnable = true;  
        }
        else if (kodaUkaza.equalsIgnoreCase("STOP")){
           komentarCPE1 = "Ustavil sem se ";  // izvedba ukaza stop
           komentarCPE2 = "";
           programCounter--;
           running = false;
           repaint();
        }
        else if (kodaUkaza.equalsIgnoreCase("IZPIS")){
           zaslon.append("\n" + new Integer(akumulatorValue).toString());
        }
        programCounter ++; //pripravim se na izvedbo naslednjega ukaza
     }
  }

   private String showBinCode(int value, int places) {
      //pretvori integer v dvojisko predstavitev
     int ostanek;
     String binCode = "";
     for (int i= 0; i <places; i++) {
         ostanek = value % 2;
         if(ostanek ==0) binCode = "0" + binCode; else binCode = 1 + binCode;
         value = value /2;
     }
     return (binCode);
   }
//*********************************************************************
  public void paint(Graphics  g) {
     // Wipe off everything that has been drawn before , otherwise previous drawings would also be displayed. 
     bufferGr.clearRect(0,0,dim.width,dim.width); 
     akumulator.setText(new Integer(akumulatorValue).toString());
     if(akumulatorValue==0) rezultatNic.setState(true); else rezultatNic.setState(false);
     if(akumulatorValue < 0) rezultatNegativen.setState(true); else rezultatNegativen.setState(false);
     int cellHeight = 18;  // visina pomnilniske celice
     // narisemo CPE...
     bufferGr.drawImage(imageCPE, 50,40,146,256, this);
     bufferGr.drawImage(imageArrow, 250,35 + programCounter*cellHeight,51,24, this);
     bufferGr.setColor(Color.black);
     bufferGr.setFont(new Font("Helvetica",Font.BOLD,12));
     bufferGr.drawString(komentarCPE1,60,60); bufferGr.drawString(komentarCPE2,60,80);
     // narisemo pomnilnik in njegovo vsebino
      bufferGr.setColor(Color.yellow);
      bufferGr.drawString("Pomnilnik",300,30 );
      // celico klicocega programa pobarvamo rumeno..
     int klicPodprograma = -1 ; // predpostavimo, da program ni bil prekinjen
     if(!sklad.empty()) {
         klicPodprograma = sklad.peek();
     }
     for (int i = 0; i< memSize; i++) {
        // narisemo pomnilno celico...
        if (i< osLimit) bufferGr.setColor(Color.lightGray);  // do tu je OS
        else bufferGr.setColor(Color.white);   // tu pa je prostor za aplikacijo
        if(i==klicPodprograma) bufferGr.setColor(Color.yellow);
        bufferGr.fillRect(300,35 + i*cellHeight, 120, cellHeight ); 
        bufferGr.setColor(Color.blue);
        bufferGr.drawRect(300,35 + i*cellHeight, 120, cellHeight ); // narisemo  pomnilno celico
        
        // vsebino pomnilne celice zapisemo kot mnemonik ali v esetiski ali dvojiski obliki...
        StringTokenizer st = new StringTokenizer(koda[i]);
        // koda ukaza
        String kodaUkaza = "";
        if (st.hasMoreTokens()) kodaUkaza = st.nextToken();   
        kodaUkaza = kodaUkaza.trim();// to je operacija ukaza
        String operand = "";
        if(st.hasMoreTokens()) operand = st.nextToken(); operand = operand.trim();
        int k = 0;  boolean found = false;
        while ((!found)&&(k<21)) {
          if(kodaUkaza.equalsIgnoreCase(opMnemonik[k])) found = true; else k++;
        }
        System.out.println("koda ukaza = " + kodaUkaza);
        switch (prikazKode){
           case 0:
              break;
           case 1:
               if (found)kodaUkaza = new Integer(opKoda[k]).toString(); 

               else if(lokacijaDefinirana[i]) ;//kodaUkaza = new Integer(koda[i]).toString(); // ce to ni ukaz, je podatek
               else kodaUkaza = ".....";  // lokacija ni definirana, je karkoli
              if (kodaUkaza.length() <2) kodaUkaza = " " + kodaUkaza; // desno ravnanje
              if (operand.length() <2 )  operand = " " + operand; // desno ravnanje
              break;
           case 2:
             if (found) {
                 kodaUkaza = showBinCode(opKoda[k],5);
                 if(!operand.equals(""))operand = showBinCode (Integer.parseInt(operand),11);  // dvojiska predstavitev
             }
             else if(lokacijaDefinirana[i]) {
                  // ce je to numericna vrednost, jo izpisemo, lahko pa je to le psevdo koda
               String st2 = "";
               try {
                 kodaUkaza = showBinCode(Integer.parseInt(kodaUkaza),16);
               }
               catch(NumberFormatException e){}
             }
             else kodaUkaza = "................";  // vsebina ni definirana
              break;     
        }
        bufferGr.drawString(kodaUkaza + " " + operand,305,50 + i*cellHeight );
        bufferGr.setColor(Color.yellow);
        bufferGr.drawString(new Integer(i).toString(),425,50 + i*cellHeight  );
        if(prikazKomentarja) {
           bufferGr.setColor(Color.lightGray);
           bufferGr.drawString(komentar[i],450,50 + i*cellHeight  );
        }
     }
    if (prekinitev){
        prekinitev = false;
        bufferGr.setColor(Color.red);
        int numpoints = 11;
        int[] xpoints = new int[numpoints+1];
        int[] ypoints = new int[numpoints+1];
        xpoints[0] = 48; ypoints[0] = 410;
        xpoints[1] = 10; ypoints[1] = 410;
        xpoints[2] = 10; ypoints[2] = 237;
        xpoints[3] = 46; ypoints[3] = 237;
        xpoints[4] = 46; ypoints[4] = 230;
        xpoints[5] = 66; ypoints[5] = 240;
        xpoints[6] = 46; ypoints[6] = 250;
        xpoints[7] = 46; ypoints[7] = 243;
        xpoints[8] = 16; ypoints[8] = 243;
        xpoints[9] = 16; ypoints[9] = 404;
        xpoints[10] = 48; ypoints[10] = 404;
        xpoints[numpoints] = 48; ypoints[numpoints] = 410;
        bufferGr.fillPolygon(xpoints, ypoints, numpoints); 
    }     
    g.drawImage(offScreen,0,0,this);   // osvezi zaslon z novo narisano sliko
    repainted = true;
  }
  //**************************************************************************
  // scriptable functions
  
  public void setTerminalVisible(boolean b) {
       prikazTerminala = b;
       tipkovnica.setVisible(prikazTerminala);   zaslon.setVisible(prikazTerminala);
  }  
  
    public void setKomentarVisible(boolean b) {
       prikazKomentarja = b;
       repaint();
  }  
  
    public void setCPErunning(boolean b) {
       running = b;
  }  
    
   public void setEnableInterrupt(boolean b) {
       interruptEnable = b;
  }  
   
   public void setCPEspeed(int s) {
       cpeSpeed = 1000/s;
  }  
       
  public void setPrikazKode(int c) {
       prikazKode = c;  // 0.. mnemonik, 1..desetisko, 2.. dvojisko
       repaint();
  }      
    public void setProgramCounter(int pc) {
       programCounter = pc;
       nextCommand();
  }  
    public void naslednjiUkaz() {
        nextCommand();
  } 
    //-------------------------------------------------------------------------
    public void loadProgram(String fileName) {
       // branje datoteke s programom
       for (int i=0;i<memSize;koda[i++]= ""); // "izpraznimo pomnilnik"
       for (int i=0;i<memSize;komentar[i++]= ""); // "izpraznimo komentarje"
       for (int i=0;i<memSize;lokacijaDefinirana[i++]= false); // lokacije pomnilnika so nedefinirane
       while(!sklad.empty()) sklad.pop();  // izpraznimo sklad
       if (fileName != null) try {
            stKod  = -1;  // polje s kodami je prazno
            String str = "";
            URL url = new URL(getCodeBase(), fileName); 
            BufferedReader bf = new BufferedReader(new InputStreamReader(url.openStream()));
            while ((str = bf.readLine()) != null) { 
              if((str.equals(""))||(str.charAt(0)==';')) continue;
                StringTokenizer st = new StringTokenizer(str, ";");  // vrstico razbijemo na dva dela
                String ukaz = st.nextToken();  // prvi del je ukaz (mnemonik in operand)
                // ukaz je morda psevdo ukaz lokacija...
                StringTokenizer st1 = new StringTokenizer(ukaz);  // ukaz razbijemo na mnemonik in operand
                String mnemonik = st1.nextToken();
                if (mnemonik.equalsIgnoreCase("LOKACIJA")){
                   String lokacija = st1.nextToken();
                   stKod = new Integer(lokacija) - 1;
                }
                else if (mnemonik.equalsIgnoreCase("START")){
                   String lokacija = st1.nextToken();
                   programCounter = new Integer(lokacija);
                }
                else {
                   String koment = ""; 
                   if (st.hasMoreTokens()) koment = st.nextToken();  // to je komentar
                   stKod++; koda[stKod] = ukaz; // pomnimo ukaz ali podatek
                   lokacijaDefinirana[stKod] = true;  // vsebina lokacije je sedaj znana
                   komentar[stKod] = koment.trim(); // pomnimo komentar
                }
            }
            bf.close();
         }
         catch (Exception e) {
            komentarCPE1 = "Ne najdem programa"; komentarCPE2 = "";
         }
         repaint();
      }
     //----------------------------------------------------------------------------  
}


